// brass.cpp --    
#include <iostream>
#include <cstring>
#include "brass.h"
using std::cout;
using std::ios_base;
using std::endl;
//   Brass
Brass::Brass(const char *s, long an, double bal)
{
	std::strncpy(fullName, s, MAX - 1);
	fullName[MAX - 1] = '\0';
	acctNum = an;
	balance = bal;
}
void Brass::Deposit(double amt)
{
	if (amt < 0)
		cout << "   ; "
			  << "  .\n";
	else
		balance += amt;
}
void Brass::Withdraw(double amt)
{
	if (amt < 0)
		cout << "    ; "
			  << "  .\n";
	else if (amt <= balance)
	balance -= amt;
	else
		cout << "  $" << amt
			  << "   .\n"
			  << "  .\n";
}
double Brass::Balance() const
{
	return balance;
}
void Brass::ViewAcct() const
{
	//   ###.##
	ios_base::fmtflags initialState =
		cout.setf(ios_base::fixed, ios_base::floatfield);
	cout.setf(ios_base::showpoint);
	cout.precision(2);
	cout << ": " << fullName << endl;
	cout << " : " << acctNum << endl;
	cout << ": $" << balance << endl;
	cout.setf(initialState); //   
}
//  BrassPlus
BrassPlus::BrassPlus(const char *s, long an, double bal,
			double ml, double r) : Brass(s, an, bal)
{
	maxLoan = ml;
	owesBank = 0.0;
	rate = r;
}
BrassPlus::BrassPlus(const Brass & ba, double ml, double r)
			: Brass(ba) //    
{
	maxLoan = ml;
	owesBank = 0.0;
	rate = r;
}
//   ViewAcct()
void BrassPlus::ViewAcct() const
{
	//   ###.##
	ios_base::fmtflags initialState =
		cout.setf(ios_base::fixed, ios_base::floatfield);
	cout.setf(ios_base::showpoint);
	cout.precision(2);
	Brass::ViewAcct(); //   
	cout << " : $" << maxLoan << endl;
	cout << " : $" << owesBank << endl;
	cout << "  : " << 100 * rate << "%\n";
	cout.setf(initialState);
}
//   Withdraw()
void BrassPlus::Withdraw(double amt)
{
	//   ###.##
	ios_base::fmtflags initialState =
		cout.setf(ios_base::fixed, ios_base::floatfield);
	cout.setf(ios_base::showpoint);
	cout.precision(2);
	double bal = Balance();
	if (amt <= bal)
		Brass::Withdraw(amt);
	else if ( amt <= bal + maxLoan - owesBank)
	{
		double advance = amt - bal;
		owesBank += advance * (1.0 + rate);
		cout << " : $" << advance << endl;
		cout << ": $" << advance * rate << endl;
		Deposit(advance);
		Brass::Withdraw(amt);
	}
	else
		cout << "  .  .\n";
	cout.setf(initialState);
}
