// acctabc.cpp --    
#include <iostream>
#include <cstring>
using std::cout;
using std::ios_base;
using std::endl;
#include "acctabc.h"

//   
AcctABC::AcctABC(const char *s, long an, double bal)
{
std::strncpy(fullName, s, MAX - 1);
fullName[MAX - 1] = '\0';
acctNum = an;
balance = bal;
}

void AcctABC::Deposit(double amt)
{
if (amt < 0)
	cout << "   ; "
			  << "  .\n";
else
	balance += amt;
}
void AcctABC::Withdraw(double amt)
{
	balance -= amt;
}

//  
ios_base::fmtflags AcctABC::SetFormat() const
{
//   ###.##
ios_base::fmtflags initialState =
		cout.setf(ios_base::fixed, ios_base::floatfield);
cout.setf(ios_base::showpoint);
cout.precision(2);
return initialState;
}

//   Brass
void Brass::Withdraw(double amt)
{
if (amt < 0)
	cout << "    ; "
			  << "  .\n";
else if (amt <= Balance())
	AcctABC::Withdraw(amt);
else
	cout << "  $" << amt
			  << "   .\n"
			  << "  .\n";
}
void Brass::ViewAcct() const
{

ios_base::fmtflags initialState = SetFormat();
cout << " Brass: " << FullName() << endl;
cout << " : " << AcctNum() << endl;
cout << ": $" << Balance() << endl;
cout.setf(initialState);
}

//   BrassPlus
BrassPlus::BrassPlus(const char *s, long an, double bal,
			double ml, double r) : AcctABC(s, an, bal)
{
maxLoan = ml;
owesBank = 0.0;
rate = r;
}
BrassPlus::BrassPlus(const Brass & ba, double ml, double r)
			: AcctABC(ba) //    
{
maxLoan = ml;
owesBank = 0.0;
rate = r;
}

void BrassPlus::ViewAcct() const
{
ios_base::fmtflags initialState = SetFormat();
cout << " BrassPlus: " << FullName() << endl;
cout << " : " << AcctNum() << endl;
cout << ": $" << Balance() << endl;
cout << " : $" << maxLoan << endl;
cout << " : $" << owesBank << endl;
cout << "  : " << 100 * rate << "%\n";
cout.setf(initialState);
}

void BrassPlus::Withdraw(double amt)
{
ios_base::fmtflags initialState = SetFormat();

double bal = Balance();
if (amt <= bal)
	AcctABC::Withdraw(amt);
else if ( amt <= bal + maxLoan - owesBank)
{
double advance = amt - bal;
owesBank += advance * (1.0 + rate);
cout << " : $" << advance << endl;
cout << ": $" << advance * rate << endl;
Deposit(advance);
AcctABC::Withdraw(amt);
}
else
	cout << "  .  .\n";
cout.setf(initialState);
}
