//error5.cpp --  
#include <iostream>
#include <cmath> //  math.h,  unix     -lm
#include <cstring>
#include "exc_mean.h"
class demo
{
private:
	char word[40];
public:
	demo (const char * str)
	{
		std::strcpy(word, str);
		std::cout << "demo " << word << " \n";
	}
	~demo()
	{
		std::cout << "demo " << word << " \n";
	}
	void show() const
	{
		std::cout << "demo " << word << " !\n";
	}
};
//  
double hmean(double a, double b) throw(bad_hmean);
double gmean(double a, double b) throw(bad_gmean);
double means(double a, double b) throw(bad_hmean, bad_gmean);
int main()
{
	using std::cout;
	using std::cin;
	using std::endl;
	double x, y, z;
	demo d1(",   main(), ");
	cout << "  : ";
	while (cin >> x >> y)
	{
		try { //   try
			z = means(x,y);
				cout << "   " << x << "  " << y
					  << "  " << z << endl;
				cout << "  : ";
		} //   try
		catch (bad_hmean & bg) //  catch
		{
			bg.mesg();
			cout << " .\n";
			continue;
		}
		catch (bad_gmean & hg)
		{
			cout << hg.mesg();
			cout << " : " << hg.v1 << ", "
				  << hg.v2 << endl;
			cout << ",    .\n";
			break;
		} //   catch
	}
	d1.show();
	cout << " !\n";
	return 0;
}
double hmean(double a, double b) throw(bad_hmean)
{
	if (a == -b)
		throw bad_hmean(a,b);
	return 2.0 * a * b / (a + b);
}
double gmean(double a, double b) throw(bad_gmean)
{
	if (a < 0 || b < 0)
		throw bad_gmean(a,b);
	return std::sqrt(a * b);
}
double means(double a, double b) throw(bad_hmean, bad_gmean)
{
	double am, hm, gm;
	demo d2(",   means(),");
	am = (a + b) / 2.0; 			//    
	try
	{
		hm = hmean(a,b);
		gm = gmean(a,b);
	}
	catch (bad_hmean & bg) 	//   catch
	{
		bg.mesg();
		std::cout << "  means()\n";
		throw; 						//   
	}
	d2.show();
	return (am + hm + gm) / 3.0;
}
