// hangman.cpp --     
#include <iostream>
#include <string>
#include <cstdlib>
#include <ctime>
#include <cctype>
using std::string;
const int NUM = 26;
const string wordlist[NUM] = {"apiary", "beetle", "cereal",
	"danger", "ensign", "florid", "garage", "health", "insult",
	"jackal", "keeper", "loaner", "manage", "nonce", "onset",
	"plaid", "quilt", "remote", "stolid", "train", "useful",
	"valid", "whence", "xenon", "yearn", "zippy"};
int main()
{
  using std::cout;
  using std::cin;
  using std::tolower;
  using std::endl;
  std::srand(std::time(0));
  char play;
  cout << "    ? <y/n> ";
  cin >> play;
  play = tolower(play);
  while (play == 'y')
  {
    string target = wordlist[std::rand() % NUM];
    int length = target.length();
    string attempt(length, '-');
    string badchars;
    int guesses = 6;
    cout 	<< "   .   " << length
    		<< " ,    \n"
    		<< "   .   " << guesses
    		<< "  .\n";
    cout 	<< " : " << attempt << endl;
    while (guesses > 0 && attempt != target)
    {
      char letter;
      cout << " : ";
      cin >> letter;
      if (badchars.find(letter) != string::npos
      		|| attempt.find(letter) != string::npos)
      {
        cout << "   .  .\n";
        continue;
      }
      int loc = target.find(letter);
      if (loc == string::npos)
      {
        cout << "!\n";
        --guesses;
        badchars += letter; //   
      }
      else
      {
        cout << "!\n";
        attempt[loc]=letter;
        // ,      
        loc = target.find(letter, loc + 1);
        while (loc != string::npos)
        {
          attempt[loc]=letter;
          loc = target.find(letter, loc + 1);
        }
      }
      cout << " : " << attempt << endl;
      if (attempt != target)
      {
        if (badchars.length() > 0)
        cout << " : " << badchars << endl;
        cout << guesses << "   \n";
      }
    }
    if (guesses > 0)
   		cout << "!\n";
    else
    	cout << " ,    : " << target << ".\n";
    cout << " ? <y/n> ";
    cin >> play;
    play = tolower(play);
  }
  cout << "!\n";
  return 0; 
}
